/* This file belongs to a CrossBrowdy.com example, made by Joan Alba Maldonado. Creative Commons Attribution 4.0 International License. */

/*
	Symbols meaning:
		" " (space)	=> Blank space.
		"@"			=> Main character (player).
		"#"			=> Walls.
		"$"			=> Pieces to move.
		"-"			=> Empty holes to put pieces in.
		"+"			=> Holes with a piece inside.
		"*"			=> Main character (player) above a hole.
*/


//Levels array:
var LEVELS =
[
	//Level 0:
	[
		"    #####          ".split(""),
		"    #   #          ".split(""),
		"    #$  #          ".split(""),
		"  ###  $##         ".split(""),
		"  #  $ $ #         ".split(""),
		"### # ## #   ######".split(""),
		"#   # ## #####  --#".split(""),
		"# $  $          --#".split(""),
		"##### ### #@##  --#".split(""),
		"    #     #########".split(""),
		"    #######        ".split("")
	],

	//Level 1:
	[
		"##########".split(""),
		"####   # #".split(""),
		"#- $ $-# #".split(""),
		"#- *$ ## #".split(""),
		"#$ $  $--#".split(""),
		"#  #######".split("")
	],
	
	//Level 2:
	[
		"############  ".split(""),
		"#--  #     ###".split(""),
		"#--  # $  $  #".split(""),
		"#--  #$####  #".split(""),
		"#--    @ ##  #".split(""),
		"#--  # #  $ ##".split(""),
		"###### ##$ $ #".split(""),
		"  # $  $ $ $ #".split(""),
		"  #    #     #".split(""),
		"  ############".split("")
	],
	
	//Level 3:
	[
		"##   #   #  ##".split(""),
		"#            #".split(""),
		"##### $@$ ####".split(""),
		"-   ##$$$##  -".split(""),
		"#        #   #".split(""),
		"--   #      --".split(""),
		"--  ##$$$ # --".split(""),
		"##### $ $ ####".split(""),
		"##            ".split(""),
		"###   #  #  ##".split("")
	],
	
	//Level 4:
	[
		"        ######## ".split(""),
		"        #     @# ".split(""),
		"        # $#$ ## ".split(""),
		"        # $  $#  ".split(""),
		"        ##$ $ #  ".split(""),
		"######### $ # ###".split(""),
		"#----  ## $  $  #".split(""),
		"##---    $  $   #".split(""),
		"#----  ##########".split(""),
		"########         ".split("")
	],
	
	//Level 5:
	[
		"# # # #     # # #".split(""),
		"   $      #      ".split(""),
		"#        $  -   #".split(""),
		" $ $ $ $  #$ # $ ".split(""),
		" # # # # #-      ".split(""),
		"  -   -   $# #-#-".split(""),
		"# $ $  #$#- $ $ $".split(""),
		" - -  -       -  ".split(""),
		"   #$#$#  $      ".split(""),
		"#- - -  #-#-#-#*#".split("")
	],
	
	//Level 6:
	[
		"           ########".split(""),
		"           #  ----#".split(""),
		"############  ----#".split(""),
		"#    #  $ $   ----#".split(""),
		"# $$$#$  $ #  ----#".split(""),
		"#  $     $ #  ----#".split(""),
		"# $$ #$ $ $########".split(""),
		"#  $ #     #       ".split(""),
		"## #########       ".split(""),
		"#    #    ##       ".split(""),
		"#     $   ##       ".split(""),
		"#  $$#$$  @#       ".split(""),
		"#    #    ##       ".split(""),
		"###########        ".split("")
	],
	
	//Level 7:
	[
		"#  ####  #### #### ".split(""),
		"####--####--###--##".split(""),
		"*                  ".split(""),
		"#  #  #  #  # #  ##".split(""),
		"#  #  #  #  # #   #".split(""),
		"#     #          ##".split(""),
		"#  #   #  #  #$$$ #".split(""),
		"#     $     #  #  #".split(""),
		"##### $   ###  #  #".split(""),
		"#    $$$ $  #  $$$#".split(""),
		"##  # #  #  #  #  #".split(""),
		"      #  #     #   ".split(""),
		" ####-####--####--#".split(""),
		"##  ###  ####  ####".split("")
	],
	
	//Level 8:
	[
		"        #####    ".split(""),
		"        #   #####".split(""),
		"        # #$##  #".split(""),
		"        #     $ #".split(""),
		"######### ###   #".split(""),
		"#----  ## $  $###".split(""),
		"#----    $ $$ ## ".split(""),
		"#----  ##$  $ @# ".split(""),
		"#########  $  ## ".split(""),
		"        # $ $  # ".split(""),
		"        ### ## # ".split(""),
		"          #    # ".split(""),
		"          ###### ".split("")
	],
	
	//Level 9:
	[
		"################ ".split(""),
		" * #-            ".split(""),
		"  ##$#########   ".split(""),
		"#             # #".split(""),
		"#  # #######  # #".split(""),
		"# $       - $ #$#".split(""),
		"# #  ###### # # #".split(""),
		"# # #  $ -  #   #".split(""),
		"###  # ####$  # #".split(""),
		"# #           # #".split(""),
		"#  ##########-#  ".split(""),
		"#--         $-$  ".split(""),
		" ############### ".split("")
	],
		
	//Level 10:
	[
		"######  ### ".split(""),
		"#--  # ##@##".split(""),
		"#--  ###   #".split(""),
		"#--     $$ #".split(""),
		"#--  # # $ #".split(""),
		"#--### # $ #".split(""),
		"#### $ #$  #".split(""),
		"   #  $# $ #".split(""),
		"   # $  $  #".split(""),
		"   #  ##   #".split(""),
		"   #########".split("")
	],
		
	//Level 11:
	[
		"    #     ##".split(""),
		" -- #$#$ #  ".split(""),
		" #    #@ #- ".split(""),
		" # - $$$ # #".split(""),
		"  #    -#-$ ".split(""),
		"  $  #  #-$ ".split(""),
		"   ## - ##$ ".split(""),
		"  # $  $ #  ".split(""),
		"  #-    -# $".split(""),
		"  #######   ".split(""),
		"--       $ -".split("")
	],
		
	//Level 12:
	[
		"       ##### ".split(""),
		" #######   ##".split(""),
		"## # @## $$ #".split(""),
		"#    $      #".split(""),
		"#  $  ###   #".split(""),
		"### #####$###".split(""),
		"# $  ### --# ".split(""),
		"# $ $ $ ---# ".split(""),
		"#    ###---# ".split(""),
		"# $$ # #---# ".split(""),
		"#  ### ##### ".split(""),
		"####         ".split("")
	],
		
	//Level 13:
	[
		"#   #   # ###".split(""),
		" # # # # #   ".split(""),
		"- #  -#- -#  ".split(""),
		"$ # $ # $ #  ".split(""),
		" #  -$   #-- ".split(""),
		" $-  $* $ $++".split(""),
		"   $- #$     ".split(""),
		" # #   $ # $ ".split(""),
		"  #-$$# $ #--".split(""),
		"  #   #  -#$ ".split(""),
		" # #-# #-##  ".split(""),
		"#   #   #  ##".split("")
	],
		
	//Level 14:
	[
		"  ####          ".split(""),
		"  #  ###########".split(""),
		"  #    $   $ $ #".split(""),
		"  # $# $ #  $  #".split(""),
		"  #  $ $  #    #".split(""),
		"### $# #  #### #".split(""),
		"#@#$ $ $  ##   #".split(""),
		"#    $ #$#   # #".split(""),
		"#   $    $ $ $ #".split(""),
		"#####  #########".split(""),
		"  #      #      ".split(""),
		"  #      #      ".split(""),
		"  #------#      ".split(""),
		"  #------#      ".split(""),
		"  #------#      ".split(""),
		"  ########      ".split("")
	]
];